( 3iArpeggiator.fs - AE -  Round 2:  2021-08-10---Tue---04:52 )
\ V3 - 2021-05-15---Sat---16:57 - Integrated with Arpeggitor on piano board with lights board and keyboard (not 4x4"

\ ============= SOUND BOARD for arpeggios 

\ Harware: Arduino Nano + 13-key directly connected piano keyboard + 32-led pianolights board
\ Firmware: 3iForth.avr + Piano.avr
\ Software: GForth, include 3iForth  3iSound-4x4.fs  3iShift.fs  include 3iPianoLights.fs 3iArpeggiator.fs

\ 1 open-com  13 start-speaker

\ 6-byte key press tuples  (extracted from 3iRecord.fs)
: fetch-note-data  ( <serial> -- numbytes ) 6 read-com ;  \ reads from serial buffer into rx-buffer
: show-note-data   ( -- ) rx-buffer 6 show-rx 2drop ;
: extract-note ( -- note-id ) rx-buffer 2 wwords + [parse-note] nip ;

\ ARPEGGIOS
 : c-arpeg  cc      mj  c_  note  begin   e_  note  g_  note  e_   note c_   note  key?  until key ;
 : d-arpeg  dd      mj  d_  note  begin   f#_ note  a_  note  f#_  note d_   note  key?  until key ; 
 : e-arpeg  ee      mj  e_  note  begin   g#_ note  b_  note  g#_  note e_   note  key?  until key ; 
 : f-arpeg  ff      mj  f_  note  begin   a_  note  c'  note  a_   note f_   note  key?  until key ;
 : g-arpeg  gg      mj  g_  note  begin   b_  note  d'  note  b_   note g_   note  key?  until key ;
 : dm-arpeg dd      mn  d_  note  begin   f_  note  a_  note  f_   note d_   note  key?  until key ;
 : a-arpeg  aa      mj  a_  note  begin   c#' note  e'  note  c#'  note a_   note  key?  until key ;
 : b-arpeg  bb      mj  b_  note  begin   d#' note  f#' note  d#'  note b_   note  key?  until key ;
 : b%-arpeg bb %%   mj  b%_ note  begin   d'  note  f'  note  d'   note b%_  note  key?  until key ;  \ 2 4 5  2 4 5  2 4 5 6# 6 4 5
 : c'-arpeg cc 7 +  mj  c'  note  begin   e'  note  g'  note  e'   note c'   note  key?  until key ;
 create key-arpeggios    ' c-arpeg , ' d-arpeg , ' e-arpeg , ' f-arpeg , ' g-arpeg , ' a-arpeg , ' b-arpeg , ' c'-arpeg , 
 : key-arpeg ( note-id -- )  \ type in desired arpeggio
    begin 1 - dwords key-arpeggios + @ execute 48 - dup 1 8 between? invert until drop ;

\ TO PRESS SELECT ARPEGGIOS ON THE FLY NEED TO TURN RECORDING ON ON THE KEYBOARD
\ 1 buttonsrecord  \ need to start recording for this to work!
: key/press?   fetch-note-data if extract-note -1 else key? if key drop 0 -1 else 0 then then ;
: c-arpegp  cc      mj      begin   e_  note  g_  note  e_   note  c_   note  key/press?  until ;
: d-arpegp  dd      mj      begin   f#_ note  a_  note  f#_  note  d_   note  key/press?  until ; 
: e-arpegp  ee      mj      begin   g#_ note  b_  note  g#_  note  e_   note  key/press?  until ; 
: f-arpegp  ff      mj      begin   a_  note  c'  note  a_   note  f_   note  key/press?  until ;
: g-arpegp  gg      mj      begin   b_  note  d'  note  b_   note  g_   note  key/press?  until ;
: dm-arpegp dd      mn      begin   f_  note  a_  note  f_   note  d_   note  key/press?  until ;
: a-arpegp  aa      mj      begin   c#' note  e'  note  c#'  note  a_   note  key/press?  until ;
: b-arpegp  bb      mj      begin   d#' note  f#' note  d#'  note  b_   note  key/press?  until ;
: b%-arpegp bb %%   mj      begin   d'  note  f'  note  d'   note  b%_  note  key/press?  until ;  \ 2 4 5   2 4 5   2 4 5 6# 6 4 5
: c'-arpegp cc 12 + mj      begin   e'  note  g'  note  e'   note  c'   note  key/press?  until ;
 create press-arpeggios  ' c-arpegp , ' d-arpegp , ' e-arpegp , ' f-arpegp , ' g-arpegp , ' a-arpegp , ' b-arpegp , ' c'-arpegp ,  
 : press-arpegp ( note-id -- ) 
    dup .. begin 1 - dwords press-arpeggios + @ execute dup 0 = if drop -1 else 0 then until ;
 
 \ revised to 1 5 3 5 picking pattern for sound of silence
 : [dm-arpeg] dd mn     d_   note   a_  note  f_  note  a_  note  ;
 : [c-arpeg]  cc mj     c_   note   g_  note  e_  note  g_  note  ;
 : [d-arpeg]  dd mj     d_   note   a_  note  f#' note  a_  note  ; 
 : [f-arpeg]  ff mj     f_   note   c'  note  a_  note  c'  note  ;
 : [g-arpeg]  gg mj     g_   note   d'  note  b_  note  d'  note  ;
 : [a-arpeg]  aa mj     a_   note   e'  note  c#' note  e'  note  ;
 : [b%-arpeg] bb %% mj  b%_  note   f'  note  d'  note  f'  note ;
 
: // 200 ms ;
: 1-2-3-4  4 0 do 32-on // 32-clear // loop ;
: end-song 32-on // 32-clear 2 0 do // 32-on // 32-clear loop ;
 
 \ sound of silence
 : silence
   32-clear
   1-2-3-4
   // [dm-arpeg]  [dm-arpeg]  [dm-arpeg]  [dm-arpeg]
   // [c-arpeg]   [c-arpeg]   [c-arpeg]   [c-arpeg]  
   // [f-arpeg]   [f-arpeg]   [b%-arpeg]  [f-arpeg]
   // [f-arpeg]   [f-arpeg]   [b%-arpeg]  [f-arpeg]
   // [f-arpeg]   [b%-arpeg]  [b%-arpeg]  [b%-arpeg] [f-arpeg] 
   // [dm-arpeg]  [dm-arpeg]  [f-arpeg]   [c-arpeg]  [c-arpeg]   
   // [dm-arpeg]  [dm-arpeg]  [dm-arpeg]  d_ note
   end-song
 ;
 

: arpeggiator 
  begin   fetch-note-data 0 > if  extract-note press-arpegp then key?
  until 32-clear ;

\ ===========================

: help-arpeg
  cr
  cr ." HELP-ARPEG (arpeggiator)"
  cr ."    Real term"
  cr ."    include 3iForth.fs  3iSound-4x4.fs  3iShift.fs  3iPianoLights.fs  3iArpeggiator.fs"
  cr ."    1 buttonsrecord   0 buttonsrecord"
  cr ."    fetch-note-data show-note-data  extract-note-data"
  cr ."    press-arpegp  silence   arpeggiator"
  cr
;

help-arpeg

\ VERSIONS
\ V1 - 
\ V2 - 2021-08-10---Tue---05:10 - cleaned up code, got working without 3iRecord.fs
